	PROGRAM DERB
C
C **********************************************************************
C *                                                                    *
C *                 PROGRAMME DE MISE A L ECHELLE ABSOLUE              *
C *                                                                    *
C **********************************************************************
C
C
C	PROGRAMME DE MISE A L ECHELLE ABSOLUE * VAX IFP *
C	PREMIERE VERSION MISE AU POINT PAR P GOUTIN (Fev 1982) A
C	L'IFP ( STAGIAIRE INFORMATIQUE UNIVERSITE DE COMPIEGNE )
C	** PDP 11 23 LABO DE DIFFRACTION X IFP **
C
C
C	PRESENTE VERSION REVUE ET COMPLETEE PAR D ESPINAT (1983-1984)
C	** VAX IFP **
C
C
C
C	PROGRAMME PRINCIPAL
C	===================
C     Fichier entree de donnee (FACTOR.DAT)                : FOR009
C     Fichier de resultats (verification des informations) : FOR003
C     Fichier intensites (a corriger)                      : FOR002
C     Fichier intensites corrigees de : -l'absorption      : FOR001
C                                       -la polarisation 
C                                       -Lorentz
C     Fichier diffusion coherente                          : FOR004
C     Fichier diffusion incoherente                        : FOR007
C     Fichier diffusion totale independante                : FOR008
C     Fichier intensites apres remises a l'echelle absolue : FOR010
C     Fichier fonction d'interference (I/NF2)              : FOR011
C     Fichier fonction SI(S)                               : FOR012
C     Fichier fonction SI(S) pour la distribution radiale  : FOR013
C
C
C  Declarations des variables
C
      COMMON/NUM/NIN,NOUT
      DIMENSION X(10),A(4),B(4),C(10)
      REAL BUF(100,23),LAMBDA,VAL(10),MEM(4),DOT(500),XA,CX,R,XMU,XMO
      INTEGER ANS,OUI,NON,BL,DEUX,TROIS,REP,IN
      CHARACTER NFIC*40,NFAT*40,DTE*24
      CHARACTER*4 ELEM(10),COMP(10),TAB(154)
      DATA DEUX,TROIS/'2','3'/
      DATA X/0.05,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.9,1.1/
      DATA OUI,NON,BL/'O','N',' '/
      DATA NIN,NOUT,NTPE/5,6,9/
C*** use of the value of cos(2theta ibm)**2 for SiO2 with MoKalpha1 ***     
C      DATA MEM/1.54178,0.711,0.78726459,0.9499/
      DATA MEM/1.54178,0.711,0.78726459,0.9555/
C
C
C  Formats
C
C
10    FORMAT(15X,50('*')/15X,'*',48X,'*'/15X,'*',6X,'PROGRAMME
     * DE MISE A L''ECHELLE ABSOLUE',5X,'*'/15X,'*',48X,'*'/
     *15X,50('*')/)
20    FORMAT(2X,'DEFINISSEZ LE NOM DU FICHIER DE RESULTATS 
     *(sans extension) : ',$)
30    FORMAT(Q,A40)
40    FORMAT(//2X,A24/)
50    FORMAT(//2X,50('*')/' LES DONNEES POUR LA MISE A L''ECHELLE
     * ABSOLUE'/' SONT CONTENUES DANS UN FICHIER FACTOR.DAT '//)
60    FORMAT(//' DONNEZ LA COMPOSITION CHIMIQUE : (ELEMENT-%)'///)
70    FORMAT(' NOMBRE D''ELEMENTS DANS L''ECHANTILLON : ',$)
80    FORMAT(2X,'L''ECHANTILLON EST COMPOSE DE PLUS DE 10 ELEMENTS')
90    FORMAT(' ELEMENT NUMERO ',I2,' (attention la valence) : ',$)
100   FORMAT(A4)
110   FORMAT(' POURCENTAGE MASSIQUE ELEMENT NUMERO ',I2,' : ',$)
120   FORMAT(2X,A4,2X,F11.6)
130   FORMAT(2X,'DONNEES CORRECTES NON=N, OUI=DEFAUT : ',$)
140   FORMAT(A1)
150   FORMAT(2X,'*Nom de l''element ',I2,' :'3X,A4)
160   FORMAT(2X,' Pourcentage massique : ',F8.4)
170   FORMAT(2X,' Masse atomique : ',F7.3)
180   FORMAT(2X,' Valeur de MU sur RO pour CuK : ',F7.3)
190   FORMAT(2X,' Valeur de MU sur RO pour MoK : ',F7.3)
200   FORMAT(/22X,'A(I)',18X,'B(I)'//9X,'1',9X,F10.4,10X,F10.4/
     *9X,'2',9X,F10.4,10X,F10.4/9X,'3',9X,F10.4,10X,F10.4/
     *9X,'4',9X,F10.4,10X,F10.4/)
210   FORMAT(2X,' Valeur de C pour la Diffusion Compton : ',F10.4)
220   FORMAT(2X,' Diffusion Compton :'/10(15X,F5.3,5X,F10.4/))
230   FORMAT(//2X,'SAISIE DES CONDITIONS EXPERIMENTALES'/
     *2X,37('*')/2X,' LONGUEUR D''ONDE UTILISEE : CUKA 
     *(PAR DEFAUT), MOKA (2),'/2X,' AUTRE CHOIX (3) : ',$)
240   FORMAT(2X,'LONGUEUR D''ONDE UTILISEE ? ',$)
250   FORMAT(2X,'VALEUR DE COS(2 THETA PRIME) ? ',$)
260   FORMAT(2X,'COEFFICIENTS D''ABSORPTION CORRESPONDANT A 
     *LAMBDA POUR ',A4,$)
270   FORMAT(2X,'VOS COEFFICIENTS SONT-ILS BONS? '/10(2X,F10.5/),
     *2X,' REPONDEZ (O/N) : ',$)
280   FORMAT(2X,' Longueur d''onde utilisee : ',F10.7)
290   FORMAT(2X,' Valeur de COS(2 THETA PRIME)-MONOCHROMATEUR : ',F10.7)
C
      WRITE(NOUT,10)
      WRITE(NOUT,20)
      READ(NIN,30) NC,NFIC
      NFIC=NFIC(1:NC)//'.RES'
C
      OPEN(UNIT=3,NAME=NFIC,STATUS='NEW')
C
       WRITE(3,10)
       CALL JDATE(DTE)
       WRITE(3,40) DTE
C
C  Ouverture du fichier FACTOR.DAT
C
       WRITE(6,50)
       CALL OUVRE(NTPE,MAXTA,TAB)
C
       WRITE(6,60)
121    WRITE(NOUT,70)
       READ(NIN,*) IN
       IF (IN.GT.10) THEN
          WRITE(NOUT,80)
          GOTO 121
       ENDIF
       DO I=1,IN
        WRITE(NOUT,90) I
        READ(NIN,100) COMP(I)
        WRITE(NOUT,110) I
        READ(NIN,*) VAL(I)
       ENDDO
C
C	VERIFICATION DE LA COMPOSITION DE L ECHANTILLON
C	===============================================
C
       DO KL=1,IN
        WRITE(NOUT,120) COMP(KL),VAL(KL)
       ENDDO
155    WRITE(NOUT,130)
       READ(NIN,140) ANS
       IF (ANS.NE.BL.AND.ANS.NE.NON) GOTO 155
       IF (ANS.EQ.NON) GOTO 121
C
C
C   Recherche des elements dans FACTOR.DAT
C
	CALL RECHER(NOUT,NIN,NTPE,IN,MAXTA,TAB,COMP,BUF,JR,IR,IV)
C
C   Fermeture du fichier FACTOR.DAT
C
	CALL FERME(NTPE,MAXTA,TAB)
C
C ***********************************************************************
C
C  DEFINITION DE BUF(I,J)
C                            I indice echantillon 
C                            J=1* masse atomique
C                            J=2* MU sur RO CuK
C                            J=3* MU sur RO MoK
C                            J=4* MU sur RO pour lambda quelconque
C                            J=5,7,9,11 * A(1,2,3,4)
C                            J=6,8,10,12 * B(1,2,3,4)
C                            J=13 * C
C                            J+(14,23) * Diffusion Compton
C
C ***********************************************************************
C
C
C    LECTURE DU FICHIER FACTOR.DAT DANS LE FICHIER DE RESULTATS
C    ==========================================================
C
       DO I=1,IN
        WRITE(3,150) I,COMP(I)
        WRITE(3,160) VAL(I)
	WRITE(3,170) BUF(I,1)
        WRITE(3,180) BUF(I,2)
        WRITE(3,190) BUF(I,3)
        WRITE(3,200) (BUF(I,J),J=5,12)
        WRITE(3,210) BUF(I,13)
        WRITE(3,220) (X(J),BUF(I,J+13),J=1,10)
       ENDDO
C
C	CONDITIONS EXPERIMENTALES
C	=========================
C
309    WRITE(NOUT,230)
       READ(NIN,140) ANS
C
       IF ((ANS.NE.BL).AND.(ANS.NE.DEUX).AND.(ANS.NE.TROIS)) THEN 
          TYPE *,' MAUVAISE REPONSE .....'
          GOTO 309
       ENDIF
C
       IF (ANS.EQ.TROIS) THEN
          WRITE(NOUT,240)
          ACCEPT*, LAMBDA
          WRITE(NOUT,250)
          ACCEPT*, COSP
          DO I=1,IN
           WRITE(NOUT,260) COMP(I)
           ACCEPT*, BUF(I,2)
          ENDDO
          JBUF=4
359       WRITE(NOUT,270) (BUF(I,2),I=1,IN)
          READ(NIN,140) ANS
          IF (ANS.NE.OUI) THEN
             TYPE *,' RECOMMENCEZ!!!!'
             GOTO 359
          ENDIF
       ENDIF
C
       IF (ANS.EQ.BL) THEN
          JBUF=2
          LAMBDA=MEM(1)
          WRITE(3,280) LAMBDA
          COSP=MEM(3)
          WRITE(3,290) COSP
       ENDIF
C
       IF (ANS.EQ.DEUX) THEN
          JBUF=3
          LAMBDA=MEM(2)
          WRITE(3,280) LAMBDA
          COSP=MEM(4)
          WRITE(3,290) COSP
       ENDIF
C
       CALL CORREC(BUF,JBUF,IN,VAL,COSP,LAMBDA,COMP)
C
      CLOSE(UNIT=3)
C
      END
C
C
C
C	**********************************************
C	*                                            *
C	*        SUBROUTINE D INTERPOLATION          *
C	*                                            *
C	**********************************************
C
C
C
	SUBROUTINE INTERP(N,X,Y,XA,YA,IR)
	DIMENSION X(1),Y(1),P(2)
      IF(N-2) 8,6,1                                                          
    1 IR=0                                                                   
      SENS=X(N)-X(1)                                                         
      DO 2 I=2,N                                                             
      IF(SENS*(XA-X(I)).LE.0.) GO TO 3                                       
    2 CONTINUE                                                               
      IR=1                                                                   
      I=N                                                                   
      GO TO 4                                                               
    3 IF(SENS*(XA-X(1)).LT.0.) IR=1                                         
    4 K1=MAX0(I-1,2)                                                        
      K2=MIN0(I,N-1)                                                        
      DO 5 K=K1,K2                                                          
      DX1=X(K+1)-X(K)                                                       
      DX2=X(K+1)-X(K-1)                                                     
      DX3=X(K)-X(K-1)                                                       
      IF(DX1*DX2*DX3*SENS.LE.0.) GO TO 8                                    
      DA1=XA-X(K-1)                                                         
      DA2=XA-X(K)                                                           
      DA3=XA-X(K+1)                                                         
      J=K-K1+1                                                              
    5 P(J)=Y(K-1)*DA2*DA3/(DX2*DX3)-Y(K)*DA1*DA3/(DX1*DX3)+Y(K+1)*DA1*DA    
     12/(DX1*DX2)                                                           
      YA=P(1)                                                               
      IF(J.EQ.2) YA=(DA1*P(2)-DA2*P(1))/DX3                                 
      RETURN                                                                
    6 DA1=XA-X(1)                                                           
      DA2=X(2)-XA                                                           
      DA3=X(2)-X(1)                                                         
      IR=0                                                                  
      IF(DA1*DA2.LT.0.) IR=1                                                
      IF(DA3) 7,8,7                                                         
    7 YA=(Y(1)*DA2+Y(2)*DA1)/DA3                                            
      RETURN                                                                
    8 IR=-1                                                                 
	YA=32767
      PRINT 100                                                             
  100 FORMAT(1X,'* SOUS PROGRAMME SGT . TABLE INCORRECTE*')                    
      RETURN                                                                
      END                                                                   
C
C
C
C
C
C
C	********************************************************************
C	*                                                                  *
C	*                                                                  *
C	*           SOUS PROGRAMME DE CORRECTION DU FICHIER                * 
C	*                                                                  *
C	*                                                                  *
C	********************************************************************
C
C
C
C
C
C
	SUBROUTINE CORREC (BUF,JBUF,IN,VAL,COSP,LAMBDA,COMP)
C
C
C
C
	COMMON/NUM/NIN,NOUT
	COMMON/MS/NB,KPDP
	COMMON//THE,ST,ROE
	COMMON/BF/REXP(20000),XINC(20000),XCOH(20000),TAB(20000),DON(20000)
	DIMENSION RAP(20000),RT(3),VAR(20000),XXCOH(20000,10),FS2(20000)
	COMMON/MF/WIJ(20000),WPJ(20000),DAU(20000),XCOK(20000)
	DIMENSION JX(20)
	REAL LAMBDA,NATOM(10),ATOM(10),RB,SIN0,SIN1,SIN2,SIN3,THEVAL(20000)
	REAL COEF,COI,AD,XHMC,Z(20),ZM,DEN,MMO,XELE
	INTEGER NIP,ITER,NBX,NCX,NSORT,I1,J1,LI
	INTEGER*4 ICN
	DIMENSION SINK(2),SCXX(4),IA(2),AA(6),FS3(20000)
	BYTE CART(11),MEME(4)
	DATA MEME/'0','1','2','3'/
	DATA CART/' ',' ','i','t','e','r','a','t','i','o','n'/
	DATA NSC/3/
	DATA SCXX/80.,40.,26.,20./
	DATA PI/3.1415926/
	REAL DIM(3),ECHAN(3)
	DATA ECHAN/'LONG','LARG','PROF'/
	DIMENSION IEQ(2),BUF(100,23),VAL(10),X(10),Y(10)
	DATA X /0.05,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.9,1.1/
	REAL MASSE, LONG,LARG,PROF,MUTE,MURO1,COSP,XMOY
	EQUIVALENCE(XNB,IEQ)
	DATA NFIC/2/
	DATA CONV/8.7267E-3/
	DATA XHMC/0.0242625/
	DATA XAV/6.02252E+23/
	DATA CCA/1.00E-24/
	CHARACTER NOP*16,NAP*16,NUP*16,NEP*16,NFIS*16
	CHARACTER NCOH*16,NABS*16,NINT*16,NCOR*16,NDAU*16
	CHARACTER NTOT*16,NINC*16,NSIS*16,NBIS*16,FGRA*16
	CHARACTER NDIF*16,NWIJ*16,NWPJ*16,NCIS*16
	CHARACTER*4 ELEM(10)
	CHARACTER*4 CIMP(10)
	CHARACTER ILEM*4,JLEM*4
	CHARACTER COMP(*)*4
	CHARACTER TITLE*40
C
C
C
	NGRA=20
	NDIM=5400
	KPDP=0
C
C
C
C	LECTURE DU FICHIER A CORRIGER
C	=============================
C
C
C
9	WRITE(6,10)
10	FORMAT(' NOM DU FICHIER A CORRIGER :?'$)
	READ(5,12,ERR=997,END=999)NC,NFIS
12	FORMAT(Q,A16)
C
C	OUVERTURE D UN FICHIER TRANSFERT POUR LA PARTIE GRAPHIQUE
C	( NOM + '.GRA' ).
C	"""""""""""""""""""""""""""""""""""""""""""""""""""""""""
C
		DO 13 I=1,NC
13		IF(NFIS(I:I).EQ.'.') GOTO 14
14		NCHR=I-1
		FGRA=NFIS(1:NCHR)//'.GRA'
		OPEN(UNIT=NGRA,NAME=FGRA,TYPE='NEW')
		WRITE(NGRA,25) LAMBDA
C
C
	OPEN(UNIT=NFIC,NAME=NFIS,TYPE='OLD')
C	READ(NFIC,18) TITLE
C18	FORMAT(A40)
C	READ(NFIC,*,END=8)DON
C8	IF(DON(1).NE.-1.AND.DON(2).NE.-1) GOTO 99
C	NB=DON(3)
        do i=1,20000
           read (nfic,*,end=8) theval(i),rexp(i)
        enddo
   8    continue
        nb=i-1
        theta0=theval(1)*conv
        theta1=theval(nb)
        the=theval(1)
        st=theval(2)-theval(1)
        step=(theval(2)-theval(1))*conv
	WRITE(3,4050) NB
4050	FORMAT(2X,' NOMBRE DE VALEURS POUR L''INTENSITE : ',I7)
C	THE=DON(4)
C	ST=DON(7)
C	THETA1=THE+ (NB-1)* ST
	WRITE(NOUT,4040)THE,THETA1,ST
	WRITE(3,4040) THE,THETA1,ST
4040	FORMAT(2X,' DE ',F7.2,' A ',F7.2,' DEGRES PAR PAS DE 'F7.2)
C	DO 17 I=1,NB
C17	REXP(I)=DON(I+9)
	CLOSE(UNIT=NFIC)
C	THETA0=THE*CONV
C	STEP=ST*CONV
C
C
	TYPE 19
19	FORMAT(//,' TYPE DE DIFFRACTION ; TRANSMISSION = T, REFLEXION
	1 = R '$)
C
C
	READ(5,11,ERR=997,END=999)NOP
11	FORMAT(A16)
	IF(NOP.NE.'T') GOTO 22
	TYPE 21
21	FORMAT(1X,'  VOUS TRAVAILLEZ EN TRANSMISSION')
	GOTO 4110
22	WRITE(3,4060)
4060	FORMAT(2X,' VOUS TRAVAILLEZ EN REFLEXION ')
C
C
C
C	CORRECTION D'ABSORPTION
C	=======================
C
C
C
4110	TYPE 23
23	FORMAT(/2X,' CORRECTION D''ABSORPTION : '/3X,23('*')/10X,
	1' PAS DE CORRECTION : 0'/10X,' VOTRE PROPRE CORRECTION :
	2 1'/10X,' CORRECTION CALCULEE : 2  ',7X,' CHOIX : '$)
	READ(5,*,ERR=997,END=999)NIP
	WRITE(3,23)
	WRITE(3,4100) NIP
4100	FORMAT(I3)
	IF(NIP.NE.0.AND.NIP.NE.1) GOTO 100
	IF(NIP.EQ.0) GOTO 28
	TYPE 24
24	FORMAT(2X,' DONNEZ VOTRE VALEUR DE CORRECTION :')
	READ(5,*,ERR=997,END=999)COR
	WRITE(3,24)
	WRITE(3,25) COR
25	FORMAT(F10.6)
	DO 27 I=1,NB
27	TAB(I)=COR
      	GOTO 200
28	DO 29 I=1,NB
 29      TAB(I)=1.
	MASSE=1.
	GOTO 200
C
C	CORRECTION D ABSORPTION
C
100	IF(NOP.NE.'T') GOTO 102
	TYPE 4500
4500	FORMAT(2X,' COEFFICIENT D''ABSORPTION (I/I0)=(EXP(-MUX)) : ',$)
	READ(5,*) COEF
	WRITE(3,4500)
	WRITE(3,25) COEF
	COI=ALOG(COEF)
	DO 4510 I=1,NB
	THETA=THETA0+(I-1)*STEP
4510	TAB(I)=(EXP(COI/COS(THETA)))/COS(THETA)
	MASSE=1.
	GOTO 200
102	TYPE 30
30	FORMAT(2X,' DIMENSION DU PORTE ECHANTILLON : ')
	WRITE(3,30)
	DO 32 I=1,3
	TYPE 34,ECHAN(I)
34	FORMAT(1X,A4,' EN MM  = ',$)
	READ(5,*,ERR=997,END=999)DIM(I)
	WRITE(3,4080) ECHAN(I),DIM(I)
4080	FORMAT(3X,A4,' = ',F10.6)
32	CONTINUE
	DO 37 I=1,3
37	DIM(I)=DIM(I)/10.
	TYPE 42
42	FORMAT(2X,' MASSE DE L''ECHANTILLON EN GRAMME : ')
	READ(5,*,ERR=997,END=999)MASSE
	WRITE(3,42)
	WRITE(3,25) MASSE
	MURO1=0.
	DO 60 I=1,IN
60	MURO1=MURO1+(BUF(I,JBUF)*VAL(I))/100
	MUTE=MURO1*MASSE/(DIM(1)*DIM(2))
	TYPE 72
72	FORMAT(2X,' EPAISSEUR ECHANTILLON INFINIE :  NON = N OUI = O (NOT
	1 ZERO) : ')
	READ(5,11,ERR=997,END=999)NOP
	WRITE(3,72)
	WRITE(3,4200) NOP
	IF(NOP.NE.'N') GOTO 80
	DO 75 I=1,NB
	THETA=THETA0+(I-1)*STEP
75	TAB(I)=DIM(3)*(1-EXP(-2*MUTE/SIN(THETA)))/(2*MUTE)
	GOTO 200
80	DO 85 I=1,NB
85	TAB(I)=2.*DIM(3)/MUTE
C
C
C
C	CORRECTION DE POLARISATION
C	==========================
C
C
C
200	TYPE 190
190	FORMAT(/2X,' CORRECTION DE POLARISATION : '/3X,26('*'))
	WRITE(3,190)
	TYPE 205
205	FORMAT(2X,' AVEZ-VOUS UN MONOCHROMATEUR : NON N , OUI = O : '$)
	READ(5,11,ERR=997,END=999)NAP
	WRITE(3,205)
	WRITE(3,4200) NAP
	IF(NAP.NE.'N') GOTO 220
	DO 210 I=1,NB
	THETA=THETA0+(I-1)*STEP
210	TAB(I)=TAB(I)*(1.+(COS(2*THETA))**2)/2.
	GOTO 239
220	DO 225 I=1,NB
	THETA=THETA0+(I-1)*STEP
225	TAB(I)=TAB(I)*((1.+((COS(2*THETA)**2)*COSP))/(1.+COSP))
C
C
C
C	CORRECTION DE LORENTZ
C	=====================
C
C
C
239	WRITE(NOUT,230)
230     FORMAT(/2X,' CORRECTION DE LORENTZ:'/3X,21('*'))
        TYPE 240
240     FORMAT(2X,' EST-CE QU''ON LA CALCULE: OUI:O, NON:N '$)
	READ(5,11,ERR=997,END=999)NUP
	WRITE(3,230)
	WRITE(3,240)
	WRITE(3,4200) NUP
	IF(NUP.NE.'O')GOTO 250
	DO 270 I=1,NB
	THETA=THETA0+(I-1)*STEP
C  *********** Lorentz correction for transmission **************
C  *********** added by MB on Octobre 25 1994 *******************
270	TAB(I)=TAB(I)*(1./(SIN(2*THETA)))
C270	TAB(I)=TAB(I)*(1./(2.*(SIN(THETA)**2)*COS(THETA)))
C
C
250	call nomme(NCOR,'.COR',NFIS)
	write(3,4230)NCOR
4230	format(/2X,' fichier intensites corrigees : ',a16)
	write(NGRA,11) NCOR
C
C
        DO 260 I=1,NB
260	REXP(I)=REXP(I)/(TAB(I))
	NSORT=1
C
C
	CALL CREPDP(NSORT,REXP,NCOR,LAMBDA)
	CLOSE(UNIT=NSORT)
C
C
C
C	CALCUL DE LA COURBE DE GAZ
C	==========================
C
C
C
	TYPE 300
300	FORMAT(1X,///,1X,'CALCUL DE LA COURBE DE GAZ THEORIQUE',/,1X,
	138('*'))
	TATOM=0.
C
C
C	NATOM : NOMBRE D ATOMES DANS LA MASSE DE L ECHANTILLON
C
	DO 50 I=1,IN
	NATOM(I)=VAL(I)*MASSE/(BUF(I,1)*100)
50	TATOM=TATOM+NATOM(I)
	DO 51 I=1,IN
51	ATOM(I)=NATOM(I)/TATOM
	TYPE 139,LAMBDA
139	FORMAT(1X,' VALEUR DE LAMBDA : ',F10.6)
	DO 310 I=1,NB
	XCOH(I)=0.
	XCOK(I)=0.
	SINU=SIN(THETA0+((I-1)*STEP))/LAMBDA
	DO 320 J=1,IN
	M=5
	REEL=0.
C
C
C
C	CALCUL DE DIFFUSION COHERENTE
C	*****************************
C
C
C	XCOH = SOMME C(I)*(F(I)**2) C(I) CONCENTRATION ATOMIQUE
C	                            F(I) FACTEUR DE DIFFUSION  
C	XCOK = SOMME C(I)*F(I)
C
C
	DO 330 K=1,4
	REEL=REEL+BUF(J,M)*EXP(-BUF(J,M+1)*SINU**2)
330	M=M+2
	XCOH(I)=XCOH(I)+(((REEL+BUF(J,M))**2)*ATOM(J))
	XCOK(I)=XCOK(I)+(REEL+BUF(J,M))*ATOM(J)
320	CONTINUE
310	CONTINUE
C
C
4150	format(2X,' fichier de resultats diffusion coherente : ',a16)
	call nomme(NCOH,'.COH',NFIS)
	write(3,4150) NCOH
	write(NGRA,11) NCOH
C
C
	NSORT=4
	CALL CREPDP(NSORT,XCOH,NCOH,LAMBDA)
	CLOSE(UNIT=NSORT)
C
C
C
C	*****************************************************************
C	[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
C
C
C
C	CETTE PARTIE CONCERNE LE CALCUL DE LA DIFFUSION DUE AUX
C	DIFFERENCES ENTRE FACTEURS DE DIFFUSION (DIFFUSION DE DAUE)
C	ET LES COEFFICIENTS DES FONCTIONS D'INTERFERENCES PARTIELLES
C	-VOIR THESE ANDONOV-
C
C
C	ON PEUT SUIVANT LE CHOIX CREER QUATRE FICHIERS /
C		XXCOH(J)=FI(K) ____ FOR015
C		WIJ(K)=FI(K)*FJ(K)/<F(K)**2> ____ FOR016
C		WPJ(K)=FI(K)*FJ(K)/<F(K)>**2 ____ FOR017
C		DAU(K)=(<F**2>/<F>**2)-1. ____ FOR018
C
C
C
C	****************************************************************
C	[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
C
C
C
C
	NSORT=14
4942	WRITE(6,4922)
4922	FORMAT(' VOULEZ VOUS CALCULER LA DIFFUSION DE LAUE OU LES',/,'
	1 COEFFICIENTS DES FONCTIONS D INTERFERENCES PARTIELLES : ',/,'
	2 SI OUI-1-, SI NON-ZERO- : ',$)
	READ(5,*) LI
	IF(LI.EQ.0) GOTO 4151
	WRITE(3,4922)
	WRITE(3,511) LI
511	FORMAT(I4)	
C
C	
	DO 4430 I=1,NB
	SINU=SIN(THETA0+((I-1)*STEP))/LAMBDA
	DO 4420 J=1,IN
	XE=0.
	M=5
	XXCOH(I,J)=0.
	DO 4440 L=1,4
	XE=XE+BUF(J,M)*EXP(-BUF(J,M+1)*SINU**2)
4440	M=M+2
	XXCOH(I,J)=XE+BUF(J,M)
4420	CONTINUE
4430	CONTINUE
C
C
	WRITE(6,4913)
4913	FORMAT(' COMBIEN D ELEMENTS SERONT PRIS EN COMPTE POUR CALCULER',/,
	1' LA DIFFUSION DE LAUE / ',$)
	READ(5,*) AM
	DO 4914 I=1,AM
	WRITE(6,4911) I
4911	FORMAT(' ELEMENT NUMERO ',I4,'  ',$)
	READ(5,4916) ELEM(I)
4916	FORMAT(A4)
	WRITE(6,4918) ELEM(I)
4918	FORMAT('  ',A4)
	DO 4915 J=1,IN
	ICN=INDEX(ELEM(I),CIMP(J))
	WRITE(6,4918) CIMP(J)
4915	IF(ICN.EQ.1) JX(I)=J
	WRITE(6,4917) JX(I)
4917	FORMAT(I4)
4914	CONTINUE
C
C
	WRITE(6,4923)
4923  FORMAT(2X,' VOULEZ VOUS L''IMPRESSION DES FACTEURS DE 
     *DIFFUSION POUR'/2X,' LES ELEMENTS CHOISIS (fichier .DIF) '/
     *'  SI OUI(1) SI NON(ZERO): ',$)
	READ(5,*)I4
	WRITE(3,4923)
	WRITE(3,511) I4
	IF(I4.EQ.0) GOTO 4928
C
C
4924	format(2X,' facteurs de diffusion atomique : ',a16)
	call nomme(NDIF,'.DIF',NFIS)
	write(3,4924) NDIF
	write(NGRA,11) NDIF
C
C
	NSORT=NSORT+1
	OPEN(UNIT=NSORT,NAME=NDIF,TYPE='NEW')
	WRITE(NSORT,*) NB
	WRITE(NSORT,*) THE
	WRITE(NSORT,*) ST
	DO 4925 J=1,AM
	WRITE(NSORT,4927) ELEM(J)
	K=JX(J)
	DO 4936 I=1,NB,4
4936	WRITE(NSORT,4926)(XXCOH(L,K),L=I,I+3)
4925	CONTINUE
4926	FORMAT(4F20.9)
4927	FORMAT(A4)
	CLOSE(UNIT=NSORT)
C
C
C	FS2 = SOMME (C(I)*F(I))
C
C	FS3 = SOMME C(I)*(F(I)**2)
C
C	
4928	DO 4450 I=1,NB
	FS2(I)=0.
	DO 4460 J=1,AM
	K=JX(J)
4460	FS2(I)=FS2(I)+XXCOH(I,K)*ATOM(K)
4450	CONTINUE
	DO 4900  I=1,NB
	FS3(I)=0.
	DO 4910 J=1,AM
	K=JX(J)
4910	FS3(I)=FS3(I)+(XXCOH(I,K)**2)*ATOM(K)
4900	CONTINUE
C
C
	WRITE(6,4861)
4861	FORMAT(' VOUS ALLEZ CALCULER LES COEFFICIENTS F(I)*F(J)/<F2>',/,' 
	1 OU LA FONCTION <F**2>/<F>**2-1 : ')
	WRITE(6,4871)
4871	FORMAT(' QUEL ELEMENT VOULEZ VOUS F(I) : ',$)
	READ(5,4916) ILEM
	DO 4919 J=1,IN
4919	IF(ILEM.EQ.CIMP(J)) I1=J
	WRITE(6,4880)
4880	FORMAT(' QUEL ELEMENT VOULEZ VOUS F(J) : ',$)
	READ(5,4916) JLEM
	DO 4921 J=1,IN
4921	IF(JLEM.EQ.CIMP(J)) J1=J
	WRITE(3,4890) COMP(I1),COMP(J1)
4890	FORMAT(' ELEMENT : ',A10,' ET ELEMENT : ',A10)
C
C
	WRITE(6,4931)
4931	FORMAT(' VOULEZ VOUS CALCULER FI(K)*FJ(K)/<F(K)**2>
	1 (WIJ) (1 OU ZERO) : ',$)
	READ(5,*)I5
	WRITE(3,4931)
	WRITE(3,511) I5
	IF(I5.EQ.0) GOTO 4932	
	DO 4470 I=1,NB
4470	WIJ(I)=XXCOH(I,I1)*XXCOH(I,J1)/FS3(I)
C
C
4951	format(2X,' calcul de FI(K)*FJ(K)/<F(K)**2> (WIJ) : ',a16)
	call nomme(NWIJ,'.WIJ',NFIS)
	write(3,4951) NWIJ
	write(NGRA,11) NWIJ
C
C
	NSORT=NSORT+1
	CALL CREPDP(NSORT,WIJ,NWIJ,LAMBDA)
	CLOSE(UNIT=NSORT)
C
C
4932	WRITE(6,4933)
4933	FORMAT(' VOULEZ VOUS CALCULER FI(K)*FJ(K)/<F(K)>**2
	1 (WPJ) (1 OU ZERO) : ',$)
	READ(5,*) I6
	WRITE(3,4933)
	WRITE(3,511) I6
	IF(I6.EQ.0)GOTO 4934
	DO 4471 I=1,NB
4471	WPJ(I)=XXCOH(I,I1)*XXCOH(I,J1)/(FS2(I)**2)
C
C
4954	format(/' calcul de FI(K)*FJ(K)/<F(K)**2> (WPJ) : ',a16)
	call nomme(NWPJ,'.WPJ',NFIS)
	write(3,4954) NWPJ
	write(NGRA,11) NWPJ
C
C
	NSORT=NSORT+1
	CALL CREPDP(NSORT,WPJ,NWPJ,LAMBDA)
	CLOSE(UNIT=NSORT)
C
C
4934	WRITE(6,4935)
4935	FORMAT(' VOULEZ VOUS CALCULER (<F(K)**2>/<F(K)>**2)-1
	1 SI OUI(1) SI NON(ZERO) : ',$)
	READ(5,*) I7
	WRITE(3,4935)
	WRITE(3,511) I7
	IF(I7.EQ.0) GOTO 4937
	DO 4472 I=1,NB
4472	DAU(I)=(FS3(I)/(FS2(I)**2))-1.
C
C
4952	format(' calcul de (<F**2>/<F>**2)-1, (DAU) : ',a16)
	call nomme(NDAU,'.DAU',NFIS)
	write(3,4952) NDAU
	write(NGRA,11) NDAU
C
C
	NSORT=NSORT+1
	CALL CREPDP(NSORT,DAU,NDAU,LAMBDA)
	CLOSE(UNIT=NSORT)
C
C		
4937	WRITE(6,4941)
4941	FORMAT(' VOULEZ VOUS D''AUTRES COUPLES (I,J) POUR F(I)*F(J)/<F2>
	1 SI OUI(1)-SI NON(0) ZERO : ',$)
	READ(5,*)KM
	IF(KM.EQ.1) GOTO 4942
C
C
C
C	*****************************************************************
C	[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
C
C
C
C	CALCUL DE LA DIFFUSION INCOHERENTE
C	**********************************
C
C
4151	call nomme(NINC,'.INC',NFIS)
	write(3,4250) NINC
4250	format(2X,' fichier de resultats dif incoherente : ',a16)
	write(NGRA,11) NINC
C
C
	DO 350 I=1,NB
	XINC(I)=0.
	SINU=(SIN(THETA0+(I-1)*STEP))/LAMBDA
	DO 360 J=1,IN
	N=13
	DO 370 L=1,10
370	Y(L)=BUF(J,N+L)
	IF(SINU.GE.0.05) CALL INTERP(10,X,Y,SINU,YA,IR)
	IF(SINU.LT.0.05) YA=0.0
	RB=1./(1.+2.*XHMC*LAMBDA*(SINU**2))
C ********** Change in the Breit-Dirac recoil factor *************
C ********** R = (lamba prime/lamba ) **2 ************************
C ********** see Klug Alexander page 804 *************************
C ****************** MB 26/10/1994 *******************************
C	YA=YA*(RB**2)
	YA=YA*(RB**3)
	XINC(I)=XINC(I)+(YA*ATOM(J))
360	CONTINUE
350	CONTINUE
C
C
	NSORT=7
	CALL CREPDP(NSORT,XINC,NINC,LAMBDA)
	CLOSE(UNIT=NSORT)
C
C
	call nomme(NTOT,'.TOT',NFIS)
	write(3,4260) NTOT
4260	format(2X,' fichier diffusion totale independante : ',a16)
	write(NGRA,11) NTOT
C
C
	DO 380 I=1,NB
380	TAB(I)=XCOH(I)+XINC(I)
C
C
	NSORT=8
	CALL CREPDP(NSORT,TAB,NTOT,LAMBDA)
	CLOSE(UNIT=NSORT)
C
C
C
C	CALCUL DU COEFFICIENT K DE NORMALISATION
C	========================================
C
C
C
	SIN0=2*SIN(THETA0)/LAMBDA
	SIN1=2*SIN(THETA0+(NB-1)*STEP)/LAMBDA
	NBX=NB-200
	NCX=NB-100
	SIN2=2*SIN(THETA0+(NBX-1)*STEP)/LAMBDA
	SIN3=2*SIN(THETA0+(NCX-1)*STEP)/LAMBDA
490	TYPE 500
500	FORMAT(/2X,' CALCUL DU COEFFICIENT K : COURBE THEORIQUE/
	1COURBE EXPERIMENTALE'/3X,63('*'))
	WRITE(3,500)
	TYPE 4370
4370	FORMAT(2X,' NB = NOMBRE DE POINTS ENREGISTRES  ')
	WRITE(3,4370)
	WRITE(6,4380)SIN2,SIN3
4380	FORMAT(2X,' VALEUR DE S POUR (NB-200) ',F10.6/2X,' VALEUR
	1 DE S POUR (NB-100) ',F10.6)
	WRITE(3,4380)SIN2,SIN3
	TYPE 4390
4390	FORMAT(' VALEURS DES RAPPORTS I CALCULEE/I EXPERIENCE ',/)
	RT(1)=TAB(NBX)/REXP(NBX)
	RT(2)=TAB(NCX)/REXP(NCX)
	RT(3)=TAB(NB-3)/REXP(NB-3)
	WRITE(6,4400)RT(1),RT(2),RT(3)
4400	FORMAT(2X,' VALEUR DU RAPPORT POUR (NB-200) ',F11.8/21X,
	1'POUR (NB-100) ',F11.8/22X,'POUR (NB-3)',2X,F11.8)
	WRITE(3,4400)RT(1),RT(2),RT(3)
	TYPE 4410
4410	FORMAT(' VOUS ALLEZ CHOISIR LES VALEURS DE S ',/,37('*'))	
510	TYPE 520,SIN0,SIN1
520	FORMAT(2X,' VALEUR DE 2*SIN(THETA)/LAMBDA INITIAL [ ',F10.6,' -
	1 ',F10.6,' ] : ',$)
	READ(5,*,ERR=997,END=999)SINK(1)
	WRITE(3,4160) SIN0,SIN1
4160	FORMAT(2X,' VALEUR DE 2*SIN(THETA)/LAMBDA INITIAL : ',F10.6,
	1' - ',F10.6)
	WRITE(3,25) SINK(1)
525	TYPE 530,SINK(1),SIN1
530	FORMAT(2X,' VALEUR DE 2*SIN(THETA)/LAMBDA FINAL [ ',F10.6,' -
	1 ',F10.6,' ] : ',$)
	READ(5,*,ERR=997,END=999)SINK(2)
	WRITE(3,4170) SINK(1),SIN1
4170	FORMAT(2X,' VALEUR DE 2*SIN(THETA)/LAMBDA FINAL : ',F10.6,
	1' - ',F10.6)
	WRITE(3,25) SINK(2)
535	IF(SINK(2).GT.SINK(1)) GOTO 540
	TYPE 536
536	FORMAT(/,' VALEUR DE 2*SIN(THETA)/LAMBDA HS ')
	WRITE(3,536)
	GOTO 510
540	DO 541 I=1,2
	DO 542 J=1,NB
	PARA=2*SIN(THETA0+(J-1)*STEP)/LAMBDA
	IF(SINK(I).LE.PARA) GOTO 550
542	CONTINUE
	TYPE 536
	GOTO 510
550	SINK(I)=PARA
	TYPE 8001,SINK(I)
8001	FORMAT(/,' VALEUR DE SINK : ',F10.6)
	IA(I)=J
541	AA(I)=ASIN(SINK(I)*LAMBDA/2.)/CONV
	WRITE(3,4180) SINK(1),SINK(2)
4180	FORMAT(/2X,' FIT (S) POUR LA MISE A L''ECHELLE ENTRE : ',F10.6,
	1' ET ',F10.6)
	NBR=IA(2)-IA(1)+1
	DO 551 I=IA(1),IA(2)
551	RAP(I+1-IA(1))=TAB(I)/REXP(I)
	TYPE 670
670	FORMAT(2X,' NOMBRE D''ITERATION : [1-3] : ',$)
	READ(5,*,ERR=997,END=999)ITER
671	FORMAT(I2)
	WRITE(3,670)
	WRITE(3,671) ITER
680	DO 700 I=1,ITER
	XMOY=0.
	DO 710 J=1,NBR
710	XMOY=XMOY+RAP(J)
	XMOY=XMOY/NBR
	SIGMA2=0.
	DO 720 J=1,NBR
720	SIGMA2=SIGMA2+((RAP(J)-XMOY)**2)
	SIGMA=SQRT(SIGMA2/(NBR-1))
	XMAX=XMOY+(SIGMA*1.5)
	XMIN=XMOY-(SIGMA*1.5)
	DO 730 J=1,NBR
	IF(RAP(J).LT.XMIN) RAP(J)=XMIN
	IF(RAP(J).GT.XMAX) RAP(J)=XMAX
730	CONTINUE
C
700	CONTINUE
	TYPE 800,XMOY
	READ(5,11,ERR=997,END=999)NEP
800	FORMAT('$VALEUR DE K ACCEPTABLE : ',F10.6,'[OUI=O;NON=N]: ') 
	WRITE(3,4190) XMOY
4190	FORMAT(2X,' VALEUR DE K : ',F10.6)
	WRITE(3,4200) NEP
4200	FORMAT(2X,' REPONSE : ',A16)
	IF( NEP.NE.'N') GOTO 815
	TYPE 810
810	FORMAT('$DONNE TA VALEUR  : ')
	READ(5,25,ERR=997,END=999)XMOY
	WRITE(3,810)
	WRITE(3,25) XMOY
C
C
815	call nomme(NABS,'.ABS',NFIS)
	write(3,4210)NABS
4210	format(2X,' fichier intensite remise a l''echelle abs : ',a16)
	write(NGRA,11) NABS
C
C
	DO 830 I=1,NB
830	REXP(I)=REXP(I)*XMOY
C
C
	NSORT=10
	CALL CREPDP(NSORT,REXP,NABS,LAMBDA)
	CLOSE(UNIT=NSORT)
C
C
C
C	CALCUL DE L INTENSITE I(S) QUI VA INTERVENIR DANS LA FFT
C	========================================================
C
C
C	CALCUL (I(COR)-(COMP+SOMME(C(I)*F(I)**2)))/(SOMME(C(I)*F(I)))**2
C	Dans cette expression I(COR) est l'intensite corrigee
C	COMP est l'intensite Compton
C	C(I) est la concentration molaire pour l atome I
C	F(I) est le facteur de diffusion de l atome I
C
C
C
C
	TYPE 851
851	FORMAT(2X,'CALCUL DE L''EXPRESSION :
	1 (I(COR)-(COMP+SOMME(C(I)*F(I)**2)))/(SOMME(C(I)*F(I)))**2 ')
	WRITE(3,851)
C
C
C
	call nomme(NINT,'.INT',NFIS)
	write(3,4220)NINT
4220	format(2X,' fichier fonction d''interference  : ',a16)
	write(NGRA,11) NINT
C
C
	DO 863 J=1,IN
863	Z(J)=0.
	ZM=0.
	DO 861 I=1,IN
	DO 862 K=5,11,2
862	Z(I)=Z(I)+BUF(I,K)
861	Z(I)=Z(I)+BUF(I,13)
	DO 864 I=1,IN
864	WRITE(6,865) COMP(I),Z(I)
865	FORMAT(3X,A4,' : ',F9.4)
	DO 866 I=1,IN
866	ZM=ZM+Z(I)*ATOM(I)
C
	DO 860 I=1,NB
860	REXP(I)=(REXP(I)-(XINC(I)+XCOH(I)))*(ZM**2)/(XCOK(I)**2)
C
C
	NSORT=11
	CALL CREPDP(NSORT,REXP,NINT,LAMBDA)
	CLOSE(UNIT=NSORT)
C
C
C
C	CALCUL DE S(IS)
C	===============
C
C
C
	TYPE 875
875	FORMAT(1X,' CALCUL DE LA FONCTION SI(S) ')
C
C
	call nomme(NSIS,'.SIS',NFIS)
	write(3,4270)NSIS
4270	format(2X,' fichier de la fonction si(s) : ',a16)
	write(NGRA,11) NSIS
C
C
	DO 890 I=1,NB
890	REXP(I)=REXP(I)*2.*SIN(THETA0+(I-1)*STEP)/LAMBDA
C
C
	WRITE(6,4520)
4520	FORMAT(' VOUS POUVEZ UTILISER UNE  FENETRE DE HAMMING POUR',/,
	1' LIMITER L EFFET DE LA TRONCATURE EN S ',/,'
	2 repondez oui (1) non tapez (0) : ',$)
	READ(5,*) IAD
	IF(IAD.EQ.0) GOTO 4550
C
	SMAX=2.*SIN(THETA0+(NB-1)*STEP)/LAMBDA
	DO 4551 I=1,NB
	SINU=2.*SIN(THETA0+(I-1)*STEP)/LAMBDA
	SSS=SINU/(2.*SMAX)
	FEN=0.5400+0.4600*COS(2.*PI*SSS)
	REXP(I)=REXP(I)*FEN
4551	CONTINUE
C
C
C	CALCUL DU TERME 4*PI*R2*RO(0)
C
C
4550	WRITE(6,40)
40	FORMAT(1X,' CALCUL DU TERME 4PIR2RO(0) ',/,1X,29('*'),/)
	WRITE(6,130)
130	FORMAT(//,2X,' DEFINISSEZ LA DENSITE (g.cm-3) DE L ECHANTILLON
	1 : ')
	READ(5,*) DEN
C
	WRITE(3,131) DEN
131	FORMAT(/2X,' DENSITE DU MATERIAU (g.cm-3) : ',F7.5)
C
	XELE=0.
	DO 132 I=1,IN
132	XELE=XELE+NATOM(I)*Z(I)
	ROE=XELE*DEN*XAV*CCA/MASSE
	ROE=ZM*ROE
C
C
C	CREATION D UN FICHIER SI(S) POUR LA FFT (DERFFT)
C
C
	NSORT=13
	KPDP=1
C
C
	call nomme(NCIS,'.CIS',NFIS)
	write(3,133) NCIS
133	format(2X,' fichier si(s) pour la fft : ',A16)
C
C
	CALL CREPDP(NSORT,REXP,NCIS,LAMBDA)
	CLOSE(UNIT=NSORT)
C
C
	KPDP=0	
	NSORT=12
	CALL CREPDP(NSORT,REXP,NSIS,LAMBDA)
	CLOSE(UNIT=NSORT)
	CLOSE(UNIT=NGRA)
C
C
996	RETURN
390	TYPE 400
400	FORMAT(1X,' PROBLEME DANS INTERPOLATION')
	GOTO 1001
999	TYPE 1000
1000	FORMAT(X)
997	TYPE 998
998	FORMAT(1X,' ERREUR DE SYNTAXE')
99	TYPE 101
101	FORMAT(1X,' FICHIER INEXISTANT')
	GOTO 1001
98	TYPE 97
97	FORMAT(1X,' MAUVAISE LECTURE DANS LE FICHIER')
1001	CLOSE(UNIT=NGRA)
	END
C
C
C
	FUNCTION ASIN(X)
	ASIN=ATAN(X/SQRT(1-X**2))
	RETURN
	END
C
C
C
C
                  SUBROUTINE  NOMME (NOM, IMPO, DEFO)
C                 ===================================
C
C     -------------------------------------------------------------------
C
C
C     ATTRIBUTION D'UN LABEL A UN FICHIER VAX/VMS
C
C           IMPO   :  PARTIE IMPOSEE
C           DEFO   :  PARTIE PAR DEFAUT
C
C     -------------------------------------------------------------------
C
C
      INTEGER       MM(6,2)
      CHARACTER*40  CCC(2), NAM
      CHARACTER*(*) NOM, IMPO, DEFO
      CHARACTER     NNN(40,2),  MMM(40), C
C
      EQUIVALENCE   (CCC,NNN), (NAM,MMM)
C
C
C     Preliminaires
C
      CCC(1) =  IMPO
      CCC(2) =  DEFO
C
C
C     Analyse des labels
C
      DO 180  J = 1, 2
      MM(1,J)  =  0
      MM(2,J)  =  0
      MM(3,J)  =  0
      MM(4,J)  =  1
      MM(5,J)  =  1
      MM(6,J)  =  0
      N  =  0
      K  =  4
            DO 160  I = 1, 40
            C  =  NNN(I,J)
            IF (C .EQ. ' ')                     GO TO 170
            IF (C .EQ. ':')                     GO TO 120
            IF (C .EQ. '['  .OR.  C .EQ. '<')   GO TO 130
            IF (C .EQ. ']'  .OR.  C .EQ. '>')   GO TO 135
            IF (C .EQ. '.')                     GO TO 140
            IF (C .EQ. ';')                     GO TO 150
            N  =  N + 1
            GO TO 160
C..Noeud
  110       MM(1,J)  =  I
            MM(2,J)  =  0
            K        =  2
            GO TO 155
C..Support
  120       IF (MM(2,J) .NE. 0)   GO TO 110
            MM(2,J)  =  I
            K        =  4
            GO TO 155
C..Directory
  130       K        =  3
            GO TO 155
  135       MM(3,J)  =  I
            K        =  4
            GO TO 155
C..Nom
  140       MM(4,J)  =  I
            K        =  5
            GO TO 155
C..Type
  150       MM(5,J)  =  I
            K        =  6
  155       N  =  0
  160       CONTINUE
C
            I  =  40
C
C..Version ou Defaut
  170 IF (N .EQ. 0)   GO TO 180
      MM(K,J)  =  I 
  180 CONTINUE
C
C
      DO 190  J = 1, 2
      DO 190  I = 2, 5
  190 MM(I,J)  =  MAX0(MM(I,J), MM(I-1,J))
C
C
C
C     Choix des composantes du label
C
      KI  =  1
      N   =  1
C
      DO 240  I = 1, 6
            DO 230  J = 1, 2
            M  =  MM(I,J)
            IF (M .EQ. 0)      GO TO 240
            IF (I .EQ. 1)      GO TO 210
               KI  =  MM(I-1,J) - I/5 + 1
               IF (M .LT. KI  .AND.  I .LT.4)  GO TO 240   
  210       IF (M .LE. KI)     GO TO 230
               KM     =  M - I/4
                  DO 220  K = KI, KM
                  MMM(N)  =  NNN(K,J)
                  N  =  N + 1
                  IF (N .GT. 40)  GO TO 260
  220             CONTINUE
               GO TO 240
  230       CONTINUE
  240 CONTINUE
C
      DO 250  I = N, 40
  250 MMM(I)  =  ' '
C
  260 NOM  =  NAM
      RETURN
      END
C
C
C
C    ----------------------------------------------------------
C
	SUBROUTINE CREPDP(NSORT,VAR,NOMS,LAMBDA)
C
C
C    ----------------------------------------------------------
C
C
C	transformation en fichier lisible sur PDP
C
C
C
C    ----------------------------------------------------------	
C
C
C
	COMMON/BF/REXP(20000),XINC(20000),XCOH(20000)
	COMMON//TH,STX,ROE
	COMMON/MS/NNB,KPDP
	COMMON/MF/WIJ(20000),WPJ(20000),DAU(20000)
	DIMENSION VAR(20000)
	CHARACTER NOMS*16
	REAL LAMBDA
C
C
C
	OPEN(UNIT=NSORT,NAME=NOMS,TYPE='NEW')
	YNB=FLOAT(NNB)
	IF(KPDP.EQ.0) GOTO 1
	WRITE(NSORT,*) ROE
	WRITE(NSORT,*) LAMBDA
1	WRITE(NSORT,*)YNB
	WRITE(NSORT,*)TH
	WRITE(NSORT,*)STX
C
C
	DO 10 I=1,NNB,4
10	WRITE(NSORT,50)(VAR(J),J=I,I+3)
50	FORMAT(4F20.9)
	END			
C
C
C
C   	---------------------------------------------------------------
C
C
	SUBROUTINE JDATE(D)
C
C
C	FOURNIT LA DATE ET L HEURE D'EXECUTION DE LA TACHE.
C
C
C	---------------------------------------------------------------
C
C
	CHARACTER D*(*),DTE*12,MOIS(12)*4,HRE*8
	DATA (MOIS(I),I=1,6)/'JANV','FEVR','MARS','AVRL','MAI','JUIN'/
	DATA (MOIS(I),I=7,12)/'JUIL','AOUT','SEPT','OCT','NOV','DEC'/
C
100	FORMAT(I2,A5,I5)
C
C
	CALL IDATE(NM,J,NA)
	NA=1900+NA
	WRITE(DTE,100) J,MOIS(NM),NA
	CALL TIME(HRE)
	D=DTE//'  *  '//HRE(1:2)//' h '//HRE(4:5)
	RETURN
	END		
C
C
C
C	*******************************************************
C	*                                                     *
C	*	SOUS PROGRAMME RECHERCHE                      *
C	*                                                     *
C	*******************************************************
C
C
C	Sous programme de recherche des parametres de diffusion
c	(RX) des differents atomes.( p. goutin)
C
C
C
C
	SUBROUTINE RECHER(NOUT,NEC,NTPE,IN,MAXTA,TAB,COMP,BUF,JR,IR,IV)
	REAL BUF(100,23)
	CHARACTER TAB(*)*4
	CHARACTER COMP(*)*4
	IV=0
	IS=0
	DO 1 IR=1,IN
	IS=IS+1
	DO 11 JR=1,MAXTA
	IF(TAB(JR).EQ.COMP(IR)) GOTO 3
11	CONTINUE
	WRITE(NOUT,12)COMP(IR)
12	FORMAT(1X,' L ELEMENT ',A4,' EST INCONNU DANS LE FICHIER.')
	CALL INSERT(NOUT,NEC,NTPE,IN,MAXTA,BUF,COMP,TAB,IS)
	GOTO 1
3	NI=JR+8
	IV=1
	READ(NTPE'NI,ERR=99)(BUF(IR,K),K=1,23)
1	CONTINUE
	IR=IR-1
	RETURN
99	TYPE *,' ERREUR DE LECTURE DANS LE FICHIER FACTOR A PARTIR DE 
	1RECHER'
	CLOSE(UNIT=NTPE)
	RETURN
	END
C
C
C
C
C	***********************************************************
C	*                                                         *
C	*	SOUS PROGRAMME INSERT (APPELE PAR R)ECHER         *
C	*                                                         *
C	***********************************************************
C
C
C	Sous programme d'insertion des donnees de diffusion x
C	pour un element donnee dans le fichier FACTOR.DAT
C	(P. GOUTIN)
C
C
C
C
	SUBROUTINE INSERT(NOUT,NEC,NTPE,IN,MAXTA,BUF,COMP,TAB,I)
	INTEGER ANS,OUI,NON
	DATA OUI,NON/'O','N'/
	REAL BUF(100,23)
	CHARACTER COMP(*)*4,TAB(*)*4
	REAL BLANC
	DATA  BLANC/'    '/
	REAL MEMO (23)
	DATA MEMO/'MASS','MUCU','MUMO','  ','A1','B1','A2','B2','A3',
	1'B3','A4','B4','C','0.05','0.1','0.2','0.3','0.4','0.5','0.6'
	2,'0.7','0.9','1.1'/
	MAXTA=MAXTA+1
	TAB(MAXTA)=COMP(I)
C	
C	ENTRES DES VALEURS
C
C
	WRITE(NOUT,20)(MEMO(ITER),ITER=1,23)
20	FORMAT(1X,//,1X,72('*'),/,1X,2('*',70X,'*',/,1X),'*',18X,' NOMS
	1 DES PARAMETRES A INSERER : ',19X,'*',/,1X,2('*',70X,'*',/,1X)
	2,'*',2X,' MASSE ATOMIQUE : ',50X,'*',/,1X,'*',3X,14('='),53X,'*',
	3/,1X,'*',2X,A4,64X,'*',/,1X,'*',70X,'*',/,1X,'*',2X,
	4' COEFFICIENTS D ABSORPTION : ',39X,'*',/,1X,'*',3X,25('='),
	542X,'*',/,1X,'*',2X,3(A4,2X),50X,'*',/,1X,'*',70X,'*',/,1X,
	6'*',2X,' COEFF
	4ICIENTS DE DIFFUSION COHERENTE : ',29X,'*',/,1X,'*',3X,
	535('='),32X,'*',/,1X,'*',2X,9(A4,2X),14X,'*',/,1X,'*',70X,'*'
	6,/,1X,'*',2X,' COEFFICIENTS DE DIFFUSION INCOHERENTE D 
	7ABCISSE : ',17X,'*',/,1X,'*',3X,47('='),20X,'*',/,1X,'*',
	82X,10(A4,2X),8X,'*',/,1X,2('*',70X,'*',/,1X),72('*'))
	WRITE(NOUT,22)
22	FORMAT(1X,//,1X,' NOM DU PARAMETRE ',5X,' VALEUR ',/,2X,16('='
	1),7X,6('='))
	DO 24 J=1,3
	WRITE(NOUT,25) MEMO(J)
25	FORMAT(10X,A4,13X,$)
	ACCEPT *, BUF(I,J)
24	CONTINUE
	BUF(I,4)=0.
	DO 26 J=5,23
	WRITE(NOUT,25)MEMO(J)
	ACCEPT *,BUF(I,J)
26	CONTINUE
C
39	TYPE *,' VALEURS INSCRITES DANS LE FICHIER.'
	WRITE(NOUT,1518)(BUF(I,J),J=1,23)
1518	FORMAT(1X,2(2X,11(F10.5,1X)/))
	II=MAXTA+8
	WRITE(NTPE'II,ERR=99)(BUF(I,J),J=1,23)
	TYPE *,' FIN DE INSERT SNAS PB'
	RETURN
99	TYPE  *,' ERREUR D ECRITURE DANS LE FICHIER'
	RETURN
	END
C
C
C
C	*********************************************************
C	*                                                       *
C	*           SOUS PROGRAMME DE FERMETURE                 *
C	*               DE FACTOR.DAT                           *
C	*                                                       *
C	*********************************************************
C
C
C
C
C
C
	SUBROUTINE FERME(NTPE,MAXTA,TAB)
	REAL BUF(23)
	DIMENSION N(2)
	CHARACTER TAB(*)*4
C
C
C
	N(1)=NTPE
	N(2)=11
	OPEN(UNIT=N(2),NAME='FACTOR.PRO',ACCESS='DIRECT',TYPE='NEW',
	1RECORDSIZE=23,ASSOCIATEVARIABLE=NREC2,FORM='UNFORMATTED',
	2ERR=100)
	TYPE 79,MAXTA
79	FORMAT(1X,'VALEUR DE MAXTA DANS FERME : ',I3)
	DO 80 I=1,2
	NN=N(I)
	WRITE(NN'1,ERR=99)MAXTA
80	CONTINUE
	IF(MAXTA.LT.23) GOTO 90
	DO 85 II=1,2
	NN=N(II)
	M=MAXTA/23
	MAX=0
	DO 10 I=2,M+1
	MIN=MAX+1
	MAX=MAX+23
10	WRITE(NN'I,ERR=99)(TAB(K),K=MIN,MAX)
	WRITE(NN'M+2,ERR=99)(TAB(K),K=MAX+1,MAXTA)
85	CONTINUE
	GOTO 95
90	DO 96 I=1,2
	NN=N(I)
	WRITE(NN'2,ERR=99)(TAB(K),K=1,MAXTA)
96	CONTINUE
95	NA=9
	NREC2=9
	DO 105 I=1,MAXTA
	READ(NTPE'NA,ERR=101)(BUF(J),J=1,23)
	WRITE(11'NREC2,ERR=99)(BUF(J),J=1,23)
105	CONTINUE
	DO 106 I=1,2
106	CLOSE(UNIT=N(I))
	RETURN
99	TYPE *,' ERREUR D ECRITURE DANS FACTOR  A PARTIR DE SP FERME'
	RETURN
100	TYPE 1010
1010	FORMAT(1X,'ERREUR D OUVERTURE DU FICHIER DE PROTECTION')
	RETURN
101	TYPE 102
102	FORMAT(1X,'ERREUR DE LECTURE DU FICHIER')
	RETURN
	END
C
C
C
C	********************************************************
C	********************************************************
C	*        SOUS PROGRAMME D OUVERTURE DU FICHIER         *
C	*                     FACTOR.DAT                       *
C	*                                                      *
C	********************************************************
C
C
C	Sous programme permettant l'ouverture du fichier de 
C	donnees FACTOR.DAT (diffusion X)
C	(P. GOUTIN)	
C
C
	SUBROUTINE OUVRE(NTPE,MAXTA,TAB)
	CHARACTER TAB(*)*4
C
C
C
	OPEN(UNIT=NTPE,NAME='FACTOR.DAT'
	1,TYPE='OLD',ACCESS='DIRECT',RECORDSIZE=23,FORM='UNFORMATTED',
	2ASSOCIATEVARIABLE=NA,ERR=100)
	READ(NTPE'1,ERR=99) MAXTA
	TYPE 50,MAXTA
50	FORMAT(1X,'VALEUR DE MAXTA : ',I3)
	IF(MAXTA.LT.23) GOTO 90
	M=MAXTA/23
	MAX=0
	DO 85 I=2,M+1
	MIN=MAX+1
	MAX=MAX+23
85	READ(NTPE'I,ERR=99)(TAB(K),K=MIN,MAX)
	READ(NTPE'M+2,ERR=99)(TAB(K),K=MAX+1,MAXTA)
	RETURN
90	READ(NTPE'2,ERR=99)(TAB(K),K=1,MAXTA)
	RETURN
99	TYPE *,' ERREUR DE LECTURE DANS FACTOR A PARTIR DE OUVRE'
	RETURN
100	TYPE *,' ERREUR DANS L OUVERTURE DU FICHIER FACTOR.DAT'
	RETURN
	END
C
C
